varying vec4 WorldPosition;
varying vec3 WorldNormal;

varying float vm00;
varying float vm11;
varying float vm10;
varying float vm1_1;
varying float vm22;
varying float vm21;
varying float vm20;
varying float vm2_1;
varying float vm2_2;

const vec3 grace00  = vec3( 0.078908,  0.043710,  0.054161 ) ;
const vec3 grace1_1 = vec3( 0.039499,  0.034989,  0.060488 ) ;
const vec3 grace10  = vec3(-0.033974, -0.018236, -0.026940 ) ;
const vec3 grace11  = vec3(-0.029213, -0.005562,  0.000944 ) ;
const vec3 grace2_2 = vec3(-0.011141, -0.005090, -0.012231 ) ;
const vec3 grace2_1 = vec3(-0.026240, -0.022401, -0.047479 ) ;
const vec3 grace20  = vec3(-0.015570, -0.009471, -0.014733 ) ;
const vec3 grace21  = vec3( 0.056014,  0.021444,  0.013915 ) ;
const vec3 grace22  = vec3( 0.021205, -0.005432, -0.030374 ) ;

vec3 irradcoeffs (vec3 L00, vec3 L1_1, vec3 L10, vec3 L11,
                   vec3 L2_2, vec3 L2_1, vec3 L20, vec3 L21, vec3 L22,
                   vec3 n)
{
    //------------------------------------------------------------------
    // These are variables to hold x,y,z and squares and products
    
    float x2 ;
    float y2 ;
    float z2 ;
    float xy ;
    float yz ;
    float xz ;
    float x ;
    float y ;
    float z ;
    vec3 col ;
    //------------------------------------------------------------------
    // We now define the constants and assign values to x,y, and z
    
     float c1 = 0.429043 ;
     float c2 = 0.511664 ;
     float c3 = 0.743125 ;
     float c4 = 0.886227 ;
     float c5 = 0.247708 ;
    x = n[0] ; y = n[1] ; z = n[2] ;
    //------------------------------------------------------------------
    // We now compute the squares and products needed
    
    x2 = x*x ; y2 = y*y ; z2 = z*z ;
    xy = x*y ; yz = y*z ; xz = x*z ;
    //------------------------------------------------------------------
    // Finally, we compute equation 13
    
    col = c1*L22*(x2-y2)*vm22
    + c3*L20*z2 *vm20
    + c4*L00 * vm00
    - c5*L20 * vm20
    + 2.*c1*(L2_2*xy *vm2_2
             + L21*xz *vm21
             + L2_1*yz*vm2_1
             )
    + 2.*c2*(L11*x*vm11
             +L1_1*y *vm1_1
             +L10*z *vm10
             ) ;
    
    col = L00*vm00 + L11*vm11 + L10*vm10 + L1_1*vm1_1 + L22*vm22 + L21*vm21 + L20*vm20 + L2_1*vm2_1 + L2_2*vm2_2;

    
    return col ;
}
//varying vec2 TexCoords;
const float pi = 3.1415926;
//This is a shader for displaying lights, don't change
mat4 gracered = mat4(
                     0.009098, -0.004780,  0.024033, -0.014947 ,
                     -0.004780, -0.009098, -0.011258,  0.020210 ,
                     0.024033, -0.011258, -0.011570, -0.017383 ,
                     -0.014947,  0.020210, -0.017383,  0.073787
                     ) ;
mat4 gracegreen = mat4(
                       -0.002331, -0.002184,  0.009201, -0.002846 ,
                       -0.002184,  0.002331, -0.009611,  0.017903 ,
                       0.009201, -0.009611, -0.007038, -0.009331 ,
                       -0.002846,  0.017903, -0.009331,  0.041083
                       ) ;
mat4 graceblue = mat4(
                      -0.013032, -0.005248,  0.005970,  0.000483 ,
                      -0.005248,  0.013032, -0.020370,  0.030949 ,
                      0.005970, -0.020370, -0.010948, -0.013784 ,
                      0.000483,  0.030949, -0.013784,  0.051648
                      ) ;



float irradmat (mat4 M, vec3 N)
{
    vec4 p = vec4( N.xyz, 1 );
    //mat4 M2 = M;
    vec4 temp = M*p;
    return dot(p,temp);
}

void main() {
    float albedo = 110.;
    vec3 _WorldNormal = normalize(WorldNormal);
    vec3 shadeColor = vec3 (
                            albedo*
                            abs(irradcoeffs (grace00, grace1_1,grace10,grace11,grace2_2,grace2_1,
                                                grace20,grace21,grace22,_WorldNormal)
                                   )
                            ) ;
    vec2 visibility= vec2(gl_TexCoord[0].st);
    gl_FragColor =vec4(shadeColor.xyz,1);//*visibility.x;
    //gl_FragColor =vec4(vm00,0,0,1);

}