void main() {
	vec3 normal, lightDir;
	vec4 diffuse, ambient, globalAmbient, specular = vec4(0.0), finalColor = vec4(0.0);
	float NdotL, NdotHV;

    /* transform normal to eye space and normalize */
    normal = normalize (gl_NormalMatrix * gl_Normal);
    globalAmbient = gl_LightModel.ambient * gl_FrontMaterial.ambient;
    
	for (int i = 0; i < 2; i++) {
		/* get light direction */
		lightDir = normalize (vec3 (gl_LightSource[i].position) );

		/* compute angle between normal and light */
		NdotL = max( dot(normal, lightDir), 0.0);

		/* compute diffuse term */
		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[i].diffuse;

		/* compute ambient term */
		ambient = gl_FrontMaterial.ambient * gl_LightSource[i].ambient;

		if (NdotL > 0.0) {
			//normalize half vector and get dot product with normal
			NdotHV = max( dot (normal, normalize(gl_LightSource[i].halfVector.xyz)), 0.0);
			specular = gl_FrontMaterial.specular * gl_LightSource[i].specular * pow(NdotHV, gl_FrontMaterial.shininess);
            specular = clamp (specular, 0.0, 1.0);
		}

		finalColor += NdotL * diffuse + ambient + specular;

	}

	gl_FrontColor = finalColor + globalAmbient;

	gl_Position = ftransform();
}